﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Tree2
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void display (TreeNodeCollection branch,
                              DirectoryInfo dir,
                              int level = 2)
        {
            MyNode node = new MyNode ();
            node.Text = dir.Name;
            node.ToolTipText = dir.FullName;
            node.path = dir.FullName;
            branch.Add (node);

            if (level > 1)
               update (node, dir, level);
        }

        private void update (MyNode node,
                             DirectoryInfo dir,
                             int level)
        {
            node.ready = true;
            try
            {
                    DirectoryInfo[] dirs = dir.GetDirectories();
                    foreach (DirectoryInfo d in dirs)
                        display(node.Nodes, d, level - 1);
             }
             catch (Exception ex)
             {
                 TreeNode info = new TreeNode();
                 info.Text = ex.ToString();
                 info.ForeColor = Color.Red;
                 node.Nodes.Add (info);
             }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            treeView1.ShowNodeToolTips = true;
            treeView1.Nodes.Clear ();
            DriveInfo [] disks = DriveInfo.GetDrives();
            foreach (DriveInfo disk in disks)
                display (treeView1.Nodes, disk.RootDirectory);

            /*
            TreeNode item = new TreeNode();
            item.Text = "Branch";
            treeView1.Nodes.Add (item);

            TreeNode node = new TreeNode();
            node.Text = "Sub-item";
            item.Nodes.Add (node);
            */

            /*
            ListViewItem item = new ListViewItem ();
            item.Text = "New";
            item.BackColor = Color.Blue;
            item.ForeColor = Color.Red;
            listView1.Items.Add (item);
            item.SubItems.Add (new ListViewItem.ListViewSubItem ());
            item.SubItems.Add ("456");
            */

            /*
            // using System.IO;
            // DirectoryInfo dir = new DirectoryInfo(".");
            var dir = new DirectoryInfo (".");
            FileInfo [] files = dir.GetFiles ();
            // var files = dir.GetFiles ();
            // for (int i = 0; i < files.Length; i++) { FileInfo f = files[i]; }
            listView1.Items.Clear ();
            listView1.ShowItemToolTips = true;
            foreach (var f in files)
            {
               var item = new ListViewItem ();
               item.Text = f.Name;
               item.ToolTipText = f.FullName;
               item.SubItems.Add (f.Length.ToString ("### ### ##0"));
               item.SubItems.Add (f.LastWriteTime.ToString ("yyyy-MM-dd HH:mm:ss.ffff"));
               listView1.Items.Add(item);
            }
            */
        }

        private void treeView1_BeforeExpand(object sender, TreeViewCancelEventArgs e)
        {
            MyNode node = e.Node as MyNode;
            if (node != null)
                foreach (TreeNode t in node.Nodes)
                {
                    MyNode n = t as MyNode;
                    if (n != null && !n.ready)
                        update (n, new DirectoryInfo(n.path), 2);
                }
        }
    }
}
